#ifndef GLOBAL_H
#define GLOBAL_H

// common C headers
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <ctime>
#include <cmath>

// common STL headers
#include <iostream>
#include <sstream>
#include <fstream>
#include <string>
#include <vector>
#include <list>
#include <queue>
#include <deque>
#include <stack>
#include <map>
#include <algorithm>
#include <exception>
#include <memory>
#include <type_traits>
#include <tuple>
#include <functional>
#include <typeinfo>
#include <array>

// boost utilities
#include <boost/algorithm/string.hpp>

// constants
#include <const.h>

// additional utilities
#include <util/types.h>
#include <util/auxiliary.h>
#include <util/logger.h>
#include <util/translator.h>

// custom types
#include <util/point.h>
#include <util/color.h>
#include <util/rect.h>
#include <util/size.h>

#endif
